Package uk.ac.starlink.table.join

# Class ErrorSkyMatchEngine

java.lang.Object
uk.ac.starlink.table.join.AbstractSkyMatchEngine
uk.ac.starlink.table.join.ErrorSkyMatchEngine

All Implemented Interfaces:
  `MatchEngine`

Direct Known Subclasses:
  `ErrorSkyMatchEngine.InDegrees`

public class ErrorSkyMatchEngine extends AbstractSkyMatchEngine
MatchEngine which matches objects on the celestial sphere according to per-object error radii. The tuples it uses are three-element arrays of `Number` objects, representing Right Ascension, Declination, and error radius respectively, all in radians. Other similar longitude/latitude-like coordinate system may alternatively be used. Two tuples are considered to match if the distance along a great circle of their central positions is no greater than the combination of their per-object radii. This combination may be either a simple sum or the sum in quadrature, according to configuration.

A length scale must be supplied, which should be of comparable size to the average per-object error, and which affects performance but not the result. The effect of this is to provide a default for the pixellisation tuning parameter. If the tuning parameter is set directly, the length scale is ignored.

Since:
  6 Sep 2011
Author:
  Mark Taylor

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`ErrorSkyMatchEngine.InDegrees`
MatchEngine class that behaves like ErrorSkyMatchEngine but uses human-friendly units (degrees and arcseconds) rather than radians for tuple elements and match parameters.

## Constructor Summary

Constructors
Constructor
Description
`ErrorSkyMatchEngine(SkyPixellator pixellator, ErrorSummation errorSummation, double scale)`
Constructor.

## Method Summary

Modifier and Type
Method
Description
`Supplier<Coverage>`
`createCoverageFactory()`
Returns a supplier for coverage objects.
`Supplier<MatchKit>`
`createMatchKitFactory()`
Returns a factory for MatchKit instances corresponding to the current settings of this object.
`uk.ac.starlink.table.DescribedValue[]`
`getMatchParameters()`
Returns a set of DescribedValue objects whose values can be modified to modify the matching criteria.
`uk.ac.starlink.table.ValueInfo`
`getMatchScoreInfo()`
Returns a description of the value returned by the `MatchKit.matchScore(java.lang.Object[], java.lang.Object[])` method.
`double`
`getScale()`
Returns the length scale.
`double`
`getScoreScale()`
Returns unity.
`uk.ac.starlink.table.ValueInfo[]`
`getTupleInfos()`
Returns a set of ValueInfo objects indicating what is required for the elements of each tuple.
`void`
`setScale(double scale)`
Sets the length scale.
`String`
`toString()`

### Methods inherited from class uk.ac.starlink.table.join.AbstractSkyMatchEngine

`calculateSeparation, getPixellator, getTuningParameters, isSkyPosition`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### ErrorSkyMatchEngine

public ErrorSkyMatchEngine(SkyPixellator pixellator, ErrorSummation errorSummation, double scale)
Constructor.

The `errorSummation` parameter configures how the match score is assessed from the error values of two tuples. The match threshold is determined by summing the error values, either by simple addition or by addition in quadrature.

Parameters:
  `pixellator` - handles sky pixellisation
  `errorSummation` - how to combine errors; if null, simple is used
  `scale` - initial value for length scale, in radians

## Method Details

### setScale

public void setScale(double scale)
Sets the length scale.

Overrides:
  `setScale` in class `AbstractSkyMatchEngine`
Parameters:
  `scale` - rough value of per-object errors, in radians

### getScale

public double getScale()
Returns the length scale.

Overrides:
  `getScale` in class `AbstractSkyMatchEngine`
Returns:
  length scale value in radians

### getTupleInfos

public uk.ac.starlink.table.ValueInfo[] getTupleInfos()
Description copied from interface: `MatchEngine`
Returns a set of ValueInfo objects indicating what is required for the elements of each tuple. The length of this array is the number of elements in the tuple. Each element should at least have a defined name and content class. The info's `nullable` attribute has a special meaning: if true it means that it makes sense for this element of the tuple to be always blank (for instance assigned to no column).

Returns:
  array of objects describing the requirements on each element of the tuples used for matching

### getMatchParameters

public uk.ac.starlink.table.DescribedValue[] getMatchParameters()
Description copied from interface: `MatchEngine`
Returns a set of DescribedValue objects whose values can be modified to modify the matching criteria. Typically at least one of these will be some sort of tolerance separation which determines how close tuples must be to count as a match. This match engine's behaviour can be modified by calling `DescribedValue.setValue(java.lang.Object)` on the returned objects.

Returns:
  array of described values which influence the match

### getMatchScoreInfo

public uk.ac.starlink.table.ValueInfo getMatchScoreInfo()
Description copied from interface: `MatchEngine`
Returns a description of the value returned by the `MatchKit.matchScore(java.lang.Object[], java.lang.Object[])` method. The content class should be numeric (though need not be `Double`), and the name, description and units should be descriptive of whatever the physical significance of the value is. If the result of `matchScore` is not interesting (for instance, if it's always either 0 or -1), `null` may be returned.

Returns:
  metadata for the match score results

### createMatchKitFactory

public Supplier<MatchKit> createMatchKitFactory()
Description copied from interface: `MatchEngine`
Returns a factory for MatchKit instances corresponding to the current settings of this object.

The returned value is immutable, and is not affected by subsequent changes of the settings of this object.

Returns:
  match kit supplier

### createCoverageFactory

public Supplier<Coverage> createCoverageFactory()
Description copied from interface: `MatchEngine`
Returns a supplier for coverage objects. Each such coverage can be used to characterise a region of tuple space. When populated with a set of tuples A, any tuple for which the inclusion function defined by its `Coverage.createTestFactory()` method returns false is guaranteed not to match any tuple in A according to this object's match criteria.

The returned value is immutable, and is not affected by subsequent changes of the settings of this object.

If no suitable implementation is available, null may be returned.

Returns:
  supplier of coverage objects, or null

### getScoreScale

public double getScoreScale()
Returns unity.

Returns:
  scale of successful match scores, a positive finite number or NaN

### toString

public String toString()

Specified by:
  `toString` in class `AbstractSkyMatchEngine`